%%% Test bench for High-Speed Link Example %%%
clear all; close all; clc;

%%% Create channel response for the simulator %%%
channelName='C:\Documents and Settings\vlada\Desktop\vlada\research\MIT\code\Links\Channels\ATCA\peters_01_0904_B20_thru.s4p';
mode='s21';
[f,H]=extract_mode_from_s4p(channelName,mode);
figure(1)
subplot(211),plot(f*1e-9,20*log10(abs(H)),'b'); xlabel('freqyency [GHz]'); ylabel('Transfer function [dB]'); grid on;

Tsym=100e-12;
Ts=Tsym/10;
imp=xfr_fn_to_imp(f,H,Ts,Tsym); %%% Ts sampled impulse response
nsym_short=300*100e-12/Tsym; %%% persistance of the impulse response tail in the channel in terms of the number of symbols
imp_short=imp(1:floor(nsym_short*Tsym/Ts));
figure(1)
subplot(212), plot(imp,'b.-'); hold on; plot(imp_short,'r.-');ylabel('imp response');
legend('long','short');

%%% Compute initial ZFE equalizer solution
eq_tap_length=20;
eq_tap_pre=5;
eq_taps=zfe(imp_short,Tsym,Ts,eq_tap_length,eq_tap_pre)
% eq_taps=[0 1 0 0 0];

%%% Create the channel impulse response taps file, with appropriate
%%% sampling according to Ts used in the sims
cd link_top;
save eq_taps.dat eq_taps -ascii;
save link_channel.dat imp_short -ascii;


%%% Run the simulation
tic
cpu_time=cputime;
cppsim test.par;
cpu_time=cputime-cpu_time
toc
run_time=toc
cd ..
return
%%% Load the signals after simulation
x=loadsig('test.tr0');
lssig(x)
figure(1)
plotsig(x,'ch_out;xi2_rx_data_out ;xi2_xi2_clk_data ;xi2_xi2_phase_select ')
% xlima([1e-9 2e-9]);

figure(2)
eyesig(x,3*Tsym, 100*Tsym,'ch_out');

% t=evalsig(x,'TIME');
% tx_out=evalsig(x,'tx_out');
% tx_clk=evalsig(x,'tx_clk');
% tx_data=evalsig(x,'tx_data');
cd ..;
